Subscription endpoints allow you to review, compare, and manage subscriptions and their related links to assets (i.e., filters, config modifiers, translation sets).
You must be a member of the environment and be assigned to an engineer role to manage subscriptions. Learn about roles.
Create links
Add one or more subscription link(s) for the selected asset(s). A link’s settings can be independent or taken from an existing link using `fromLink`.
The request contains a list of links for one or more asset types. To link one asset to multiple subscriptions, include a link entry for each one. For example, an asset with 3 subscription links should have 3 entries in the list.
A filter can only have one subscription link.
cURL request example
Path Parameters
- environmentIdrequired, string
Identifies the specific environment that you're operating in or on behalf of.
Request Body Schema
- linksrequired, Array of object
Lists the links to create (max allowed is 50). The same asset may appear in several entries, one per subscription.
- assetrequired, object
Identifies the asset to link. It must belong to the specified environment.
- idrequired, string
Contains the unique identifier of the asset.
Format: uuid - typerequired, stringPossible Values:
configModifier,filter,translationSet
- subscriptionrequired, object
Identifies the subscription to link the asset to based on its source, destination, and data model.
- sourcerequired, object
Specifies the source of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the source.
Format: uuid
- destinationrequired, object
Specifies the destination of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the destination.
Format: uuid
- dataModelrequired, string
Specifies the Redox data model that the link applies to or should apply to.
- fromLinkobject
Identifies an existing link for the same asset type to take settings from. Any value in
linkSettingsoverrides the respective setting taken from this link.- idrequired, string
Contains the unique identifier of the link for a specified asset.
Format: uuid
- linkSettingsobject
Contains the link's settings, which depend on the asset type. A config modifier link accepts
expectedDataModel,eventTypes,ownedBy, andprocessingLocation; a translation set link acceptsexpectedDataModel,direction,processingLocation, andpaths; a filter link has no settings. A setting that doesn't apply to the asset type fails the whole request. When you givefromLink, any setting here overrides the setting taken from that link.- expectedDataModelstring
Specifies the data model when it is expected to differ from the subscription's data model. Defaults to the subscription's data model.
- eventTypesArray of string
For config modifier links only, specifies the event types of the data model that the link applies to. Set to
nullto apply the config modifier's link to every event type. - ownedBystring
For config modifier links only, indicates whether the source or destination system owns the link. Inferred from the subscription when omitted.
Possible Values:source,destination - processingLocationstring
Identifies where a link will be applied during log processing. There are up to four stages that an asset can be linked to, depending on whether you own either the source, the destination, or both.
Possible Values:source-request,destination-request,source-response,destination-response - directionstring
Indicates the direction in which the translation set is or should be linked. This can be either
from-to(translates a "from" value into a "to" value), orto-from(tranlates a "to" value into a "from" value).Possible Values:from-to,to-from - pathsArray of object
Lists the field paths linked to a translation set. These paths must be unique on the path property.
- dataTypestring
Describes the format of the data found at the path location.
- titlestring
Specifies a human-readable title for the field path.
- pathstring
Specifies the path in a message to the location of the data to be translated. The path must always start with a $ to be considered valid.
Contains the links to create within the specified environment.
- metaobject
- versionstring
Lists the major and minor version number for the format of the returned payload. The payload format or shape may change between minor versions, like including additional or extended fields in later versions. We include the version data in each response so that you have the option to handle the signaled differences.
- payloadobject
- linksArray of object
Lists the links that now exist, whether they were created by this request or already existed.
- assetobject
Identifies the asset to link. It must belong to the specified environment.
- idrequired, string
Contains the unique identifier of the asset.
Format: uuid - typerequired, stringPossible Values:
configModifier,filter,translationSet
- linkobject
- idstring
Contains the unique identifier of the link for a specified asset.
Format: uuid - subscriptionobject
Identifies the subscription to link the asset to based on its source, destination, and data model.
- sourcerequired, object
Specifies the source of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the source.
Format: uuid
- destinationrequired, object
Specifies the destination of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the destination.
Format: uuid
- dataModelrequired, string
Specifies the Redox data model that the link applies to or should apply to.
- actionstring
Indicates whether this request created the link or found an existing one that went unchanged. An
unchangedlink reports the existing link's ID.Possible Values:created,unchanged
- failuresArray of object
Lists any links that weren't added, along with the error that prevented it. See
error.meta.isTransientto learn whether you can safely retry adding a link. This array is empty when every link was added successfully.- assetobject
Identifies the asset to link. It must belong to the specified environment.
- idrequired, string
Contains the unique identifier of the asset.
Format: uuid - typerequired, stringPossible Values:
configModifier,filter,translationSet
- linkobject
Identifies the intended subscription of the failed link so the correct entry can be retried.
- subscriptionobject
Identifies the subscription to link the asset to based on its source, destination, and data model.
- sourcerequired, object
Specifies the source of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the source.
Format: uuid
- destinationrequired, object
Specifies the destination of the subscription that an asset is or should be linked to.
- idrequired, string
Contains the unique identifier of the destination.
Format: uuid
- dataModelrequired, string
Specifies the Redox data model that the link applies to or should apply to.
- errorobject
Explains why one item in a bulk request failed. The overall request still returns
200. A request that's rejected before any work starts (e.g., due to a malformed body) returns400instead.- idrequired, string
Contains a unique identifier for this error instance.
- coderequired, string
Identifies the error type, which can be used to find relevant troubleshooting information.
- titlerequired, string
Displays the high-level error message.
- detailrequired, string
Contains the specific error details for this item.
- metaobject
Contains additional details about the failure. Some errors add other properties, such as the ID of an asset that was partially created.
- isTransientboolean
Indicates whether retrying this item as-is might succeed.
truemeans the failure was temporary (e.g., a timeout), so you can retry the item.falsemeans the item will continue to fail until you correct the issue (e.g., the asset doesn't exist or its name is a duplicate). When absent, the failure wasn't classified; reviewdetailbefore retrying.